OGRE: Ogre::v1::BillboardSet Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Ogre::v1::BillboardSet Class Reference
Core » Effects

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other. More...

`#include <OgreBillboardSet.h>`

Inheritance diagram for Ogre::v1::BillboardSet:
[legend]

## Public Types
typedef map< size_t, Vector4 >::type | CustomParameterMap
typedef FastArray< MovableObject * > | MovableObjectArray
| @See SceneManager::cullFrustum More...

## Public Member Functions
| BillboardSet (IdType id, ObjectMemoryManager *objectMemoryManager, SceneManager *manager, unsigned int poolSize=20, bool externalDataSource=false, uint8 renderQueueId=110u)
| Usual constructor - this is called by the SceneManager. More...
virtual | ~BillboardSet ()
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object. More...
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only) More...
ObjectData & | _getObjectData ()
| Returns a direct access to the ObjectData state. More...
const Matrix4 & | _getParentNodeFullTransform (void) const
| Returns the full transformation of the parent sceneNode or the attachingPoint node. More...
virtual SortMode | _getSortMode (void) const
| Gets the sort mode of this billboard set. More...
virtual void | _notifyAttached (Node *parent)
| Internal method called to notify the object that it has been attached to a node. More...
virtual void | _notifyBillboardResized (void)
| Internal callback used by Billboards to notify their parent that they have been resized. More...
virtual void | _notifyBillboardRotated (void)
| Internal callback used by Billboards to notify their parent that they have been rotated. More...
virtual void | _notifyCurrentCamera (const Camera *cam)
| Overridden from MovableObject. More...
void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only) More...
virtual void | _notifyParentNodeMemoryChanged (void)
| @See Node::_callMemoryChangeListeners More...
virtual void | _notifyStaticDirty (void) const
| Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly. More...
void | _releaseManualHardwareResources ()
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored. More...
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly. More...
virtual void | _setNullDatablock (void)
| Sets the datablock to a null pointer. More...
virtual void | _sortBillboards (void)
| Sort the billboard set. More...
virtual void | _updateBounds (void)
| Update the bounds of the billboardset. More...
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. More...
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Overridden from MovableObject. More...
void | _updateRenderQueueImpl (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal version that does not call _notifyCurrentCamera (i.e. you've already done it) More...
void | addPoseWeight (size_t index, float w)
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object. More...
void | beginBillboards (size_t numBillboards=0)
| Begin injection of billboard data; applicable when constructing the BillboardSet for external data use. More...
virtual void | clear ()
| Empties this set of all billboards. More...
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value. More...
Billboard * | createBillboard (const Vector3 &position, const ColourValue &colour=ColourValue::White)
| Creates a new billboard and adds it to this set. More...
Billboard * | createBillboard (Real x, Real y, Real z, const ColourValue &colour=ColourValue::White)
| Creates a new billboard and adds it to this set. More...
void | detachFromParent (void)
| Detaches an object from a parent SceneNode if attached. More...
void | endBillboards (void)
| Finish defining billboards. More...
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object. More...
virtual bool | getAutoextend (void) const
| Returns true if the billboard pool automatically extends. More...
bool | getAutoUpdate (void) const
| Return the auto update state of this billboard set. More...
virtual Billboard * | getBillboard (unsigned int index) const
| Returns a pointer to the billboard at the supplied index. More...
virtual BillboardOrigin | getBillboardOrigin (void) const
| Gets the point which acts as the origin point for all billboards in this set. More...
virtual BillboardRotationType | getBillboardRotationType (void) const
| Sets billboard rotation type. More...
bool | getBillboardsInWorldSpace ()
| Gets whether billboards are treated as being in world space. More...
virtual BillboardType | getBillboardType (void) const
| Returns the billboard type in use. More...
RealAsUint | getCachedDistanceToCamera (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
Real | getCachedDistanceToCameraAsReal (void) const
| Returns the distance to camera as calculated in @cullFrustum. More...
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object. More...
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow. More...
virtual const Vector3 & | getCommonDirection (void) const
| Gets the common direction for all billboards (BBT_ORIENTED_COMMON) More...
virtual const Vector3 & | getCommonUpVector (void) const
| Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON) More...
virtual bool | getCullIndividually (void) const
| Returns whether or not billboards in this are tested individually for culling. More...
uint8 | getCurrentMaterialLod (void) const
unsigned char | getCurrentMeshLod (void) const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index. More...
const CustomParameterMap & | getCustomParameters (void) const
HlmsDatablock * | getDatablock (void) const
virtual Real | getDefaultHeight (void) const
| See setDefaultDimensions - this gets 1 component individually. More...
virtual Real | getDefaultWidth (void) const
| See setDefaultDimensions - this gets 1 component individually. More...
uint32 | getHlmsCasterHash (void) const
uint32 | getHlmsHash (void) const
IdType | getId () const
| Get the unique id of this object. More...
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object. More...
const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable. More...
Listener * | getListener (void) const
| Gets the current listener for this object. More...
Aabb | getLocalAabb (void) const
| Retrieves the local axis-aligned bounding box for this object. More...
float | getLocalRadius (void) const
| See getLocalAabb and getWorldRadius. More...
MaterialPtr | getMaterial (void) const
| Retrieves the material this renderable object uses. More...
virtual const String & | getMovableType (void) const
| Overridden from MovableObject. More...
const String & | getName (void) const
| Returns the name of this object. More...
virtual int | getNumBillboards (void) const
| Returns the number of active billboards which currently make up this set. More...
unsigned short | getNumPoses (void) const
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires. More...
Node * | getParentNode (void) const
| Returns the node to which this object is attached. More...
SceneNode * | getParentSceneNode (void) const
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
virtual unsigned int | getPoolSize (void) const
| Returns the current size of the billboard pool. More...
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object. More...
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered. More...
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
virtual void | getRenderOperation (RenderOperation &op, bool casterPass)
| Overridden from MovableObject. More...
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details. More...
uint8 | getRenderQueueSubGroup (void) const
Real | getShadowRenderingDistance (void) const
| Gets the distance at which batches are no longer casting shadows. More...
SkeletonInstance * | getSkeletonInstance (void) const
virtual bool | getSortingEnabled (void) const
| Returns true if sorting of billboards is enabled based on their distance from the camera. More...
Real | getSquaredViewDepth (const Camera *cam) const
| Overridden, see Renderable. More...
virtual Ogre::FloatRect const * | getTextureCoords (uint16 *oNumCoords)
| getTextureCoords() returns the current texture coordinate rects in effect. More...
virtual bool | getUseAccurateFacing (void) const
| Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction. More...
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection. More...
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view. More...
virtual bool | getUseIdentityViewProjMatrixIsDynamic (void) const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization) More...
virtual bool | getUseIdentityWorldMatrix (void) const
| Overriden from Renderable. More...
virtual OGRE_DEPRECATED const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object. More...
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component. More...
Aabb | getWorldAabb () const
| Gets the axis aligned box in world space. More...
Aabb | getWorldAabbUpdated ()
| Gets the axis aligned box in world space. More...
float | getWorldRadius () const
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
float | getWorldRadiusUpdated ()
| Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ). More...
virtual void | getWorldTransforms (Matrix4 *xform) const
| Overridden from MovableObject. More...
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index. More...
bool | hasSkeletonAnimation (void) const
void | injectBillboard (const Billboard &bb, const Camera *camera)
| Define a billboard. More...
virtual void | instanceBatchCullFrustumThreaded (const Frustum *frustum, const Camera *lodCamera, uint32 combinedVisibilityFlags)
| @See InstancingTheadedCullingMethod, More...
bool | isAttached (void) const
| Returns true if this object is attached to a Node. More...
virtual bool | isPointRenderingEnabled (void) const
| Returns whether point rendering is enabled. More...
bool | isStatic () const
| Checks whether this MovableObject is static. @See setStatic. More...
bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not. More...
void | notifyBillboardDataChanged (void)
| When billboard set is not auto updating its GPU buffer, the user is responsible to inform it about any billboard changes in order to reflect them at the rendering stage. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
bool | operator() (const IdObject &left, const IdObject &right)
bool | operator() (const IdObject *left, const IdObject *right)
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered. More...
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered. More...
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object. More...
virtual void | removeBillboard (Billboard *pBill)
| Removes a billboard from the set. More...
virtual void | removeBillboard (unsigned int index)
| Removes the billboard at the supplied index. More...
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index. More...
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object. More...
virtual void | setAutoextend (bool autoextend)
| Tells the set whether to allow automatic extension of the pool of billboards. More...
void | setAutoUpdate (bool autoUpdate)
| Set the auto update state of this billboard set. More...
virtual void | setBillboardOrigin (BillboardOrigin origin)
| Sets the point which acts as the origin point for all billboards in this set. More...
virtual void | setBillboardRotationType (BillboardRotationType rotationType)
| Sets billboard rotation type. More...
virtual void | setBillboardsInWorldSpace (bool ws)
| Sets whether billboards should be treated as being in world space. More...
virtual void | setBillboardType (BillboardType bbt)
| Sets the type of billboard to render. More...
void | setBounds (const Aabb &aabb, Real radius)
| Set the bounds of the BillboardSet. More...
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows. More...
virtual void | setCommonDirection (const Vector3 &vec)
| Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON or BBT_PERPENDICULAR_COMMON. More...
virtual void | setCommonUpVector (const Vector3 &vec)
| Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON. More...
virtual void | setCullIndividually (bool cullIndividual)
| Sets whether culling tests billboards in this individually as well as in a group. More...
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. More...
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable. More...
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e. More...
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials. More...
virtual void | setDefaultDimensions (Real width, Real height)
| Sets the default dimensions of the billboards in this set. More...
virtual void | setDefaultHeight (Real height)
| See setDefaultDimensions - this sets 1 component individually. More...
virtual void | setDefaultWidth (Real width)
| See setDefaultDimensions - this sets 1 component individually. More...
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object. More...
void | setListener (Listener *listener)
| Sets a listener for this object. More...
void | setLocalAabb (const Aabb box)
| Sets the local axis-aligned bounding box for this object. More...
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials. More...
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS @See setHlms. More...
void | setName (const String &name)
| Sets a custom name for this node. More...
virtual void | setPointRenderingEnabled (bool enabled)
| Set whether or not the BillboardSet will use point rendering rather than manually generated quads. More...
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
virtual void | setPoolSize (size_t size)
| Adjusts the size of the pool of billboards available in this set. More...
void | setPoseWeight (size_t index, float w)
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object. More...
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered. More...
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered. More...
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through. More...
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group. More...
void | setShadowRenderingDistance (Real dist)
| Sets the distance at which the object is no longer casting shadows. More...
virtual void | setSortingEnabled (bool sortenable)
| Enables sorting for this BillboardSet. More...
bool | setStatic (bool bStatic)
| Turns this Node into static or dynamic. More...
virtual void | setTextureCoords (Ogre::FloatRect const *coords, uint16 numCoords)
| BillboardSet can use custom texture coordinates for various billboards. More...
virtual void | setTextureStacksAndSlices (uchar stacks, uchar slices)
| setTextureStacksAndSlices() will generate texture coordinate rects as if the texture for the billboard set contained 'stacks' rows of 'slices' images each, all equal size. More...
virtual void | setUseAccurateFacing (bool acc)
| Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction. More...
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection. More...
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view. More...
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object. More...
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component. More...

## Static Public Member Functions
static void | buildLightList (const size_t numNodes, ObjectData t, const LightListInfo &globalLightList)
| @See SceneManager::buildLightList More...
static void | calculateCastersBox (const size_t numNodes, ObjectData t, uint32 sceneVisibilityFlags, AxisAlignedBox *outBox)
static void | cullFrustum (const size_t numNodes, ObjectData t, const Camera *frustum, uint32 sceneVisibilityFlags, MovableObjectArray &outCulledObjects, const Camera *lodCamera)
static void | cullLights (const size_t numNodes, ObjectData t, uint32 sceneLightMask, LightListInfo &outGlobalLightList, const FrustumVec &frustums, const FrustumVec &cubemapFrustums)
| @See SceneManager::cullLights & More...
static uint32 | getDefaultLightMask ()
| Get the default light mask for all future MovableObject instances. More...
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances. More...
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances. More...
static void | setDefaultLightMask (uint32 mask)
| Set the default light mask for all future MovableObject instances. More...
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances. More...
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances. More...
static void | updateAllBounds (const size_t numNodes, ObjectData t)
| @See SceneManager::updateAllBounds More...

## Public Attributes
uint8 | mCustomParameter
| Only valid when using low level materials. More...
size_t | mGlobalIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock. More...
size_t | mParentIndex
| Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks). More...
RenderableArray | mRenderables

## Static Public Attributes
static const FastArray< Real > | c_DefaultLodMesh

## Detailed Description

A collection of billboards (faces which are always facing the given direction) with the same (default) dimensions, material and which are fairly close proximity to each other.

Remarks
  Billboards are rectangles made up of 2 tris which are always facing the given direction. They are typically used for special effects like particles. This class collects together a set of billboards with the same (default) dimensions, material and relative locality in order to process them more efficiently. The entire set of billboards will be culled as a whole (by default, although this can be changed if you want a large set of billboards which are spread out and you want them culled individually), individual Billboards have locations which are relative to the set (which itself derives it's position from the SceneNode it is attached to since it is a MoveableObject), they will be rendered as a single rendering operation, and some calculations will be sped up by the fact that they use the same dimensions so some workings can be reused.

  A BillboardSet can be created using the SceneManager::createBillboardSet method. They can also be used internally by other classes to create effects.

Note
  Billboard bounds are only automatically calculated when you create them. If you modify the position of a billboard you may need to call _updateBounds if the billboard moves outside the original bounds. Similarly, the bounds do no shrink when you remove a billboard, if you want them to call _updateBounds, but note this requires a potentially expensive examination of every billboard in the set.

## Member Typedef Documentation

## ◆ CustomParameterMap

typedef map<size_t, Vector4>::type Ogre::Renderable::CustomParameterMap
| inherited

## ◆ MovableObjectArray

typedef FastArray<MovableObject*> Ogre::MovableObject::MovableObjectArray
| inherited

@See SceneManager::cullFrustum

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing) We perform frustum culling AND test visibility mask at the same time

Parameters

  frustum | Frustum to clip against
  sceneVisibilityFlags | Combined scene's visibility flags (i.e. viewport | scene). Set LAYER_SHADOW_CASTER bit if you want to exclude non-shadow casters.
  outCulledObjects | Out. List of objects that are (fully or partially) inside the frustum and should be rendered
  lodCamera | Camera in which lod levels calculations are based (i.e. during shadow pass renders) Note however, we only use this camera to calulate if should be visible according to mUpperDistance

## Constructor & Destructor Documentation

## ◆ BillboardSet()

Ogre::v1::BillboardSet::BillboardSet | ( | IdType | id,
|  | ObjectMemoryManager * | objectMemoryManager,
|  | SceneManager * | manager,
|  | unsigned int | poolSize = `20`,
|  | bool | externalDataSource = `false`,
|  | uint8 | renderQueueId = `110u`
| ) |  |

Usual constructor - this is called by the SceneManager.

Parameters

  name | The name to give the billboard set (must be unique)
  poolSize | The initial size of the billboard pool. Estimate of the number of billboards which will be required, and pass it using this parameter. The set will preallocate this number to avoid memory fragmentation. The default behaviour once this pool has run out is to double it.
  externalDataSource | If `true`, the source of data for drawing the billboards will not be the internal billboard list, but external data. When driving the billboard from external data, you must call _notifyCurrentCamera to reorient the billboards, setPoolSize to set the maximum billboards you want to use, beginBillboards to start the update, and injectBillboard per billboard, followed by endBillboards.

See also
  BillboardSet::setAutoextend

## ◆ ~BillboardSet()

virtual Ogre::v1::BillboardSet::~BillboardSet | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _getLightList()

LightList* Ogre::MovableObject::_getLightList | ( |  | ) |
| inlineinherited

Returns a pointer to the current list of lights for this object.

Remarks
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

## ◆ _getManager()

SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const
| inlineinherited

Get the manager of this object, if any (internal use only)

## ◆ _getObjectData()

ObjectData& Ogre::MovableObject::_getObjectData | ( |  | ) |
| inlineinherited

Returns a direct access to the ObjectData state.

## ◆ _getParentNodeFullTransform()

const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const
| inherited

Returns the full transformation of the parent sceneNode or the attachingPoint node.

## ◆ _getSortMode()

virtual SortMode Ogre::v1::BillboardSet::_getSortMode | ( | void |  | ) | const
| virtual

Gets the sort mode of this billboard set.

## ◆ _notifyAttached()

virtual void Ogre::MovableObject::_notifyAttached | ( | Node * | parent | ) |
| virtualinherited

Internal method called to notify the object that it has been attached to a node.

Reimplemented in Ogre::ParticleSystem, and Ogre::v1::Entity.

## ◆ _notifyBillboardResized()

virtual void Ogre::v1::BillboardSet::_notifyBillboardResized | ( | void |  | ) |
| virtual

Internal callback used by Billboards to notify their parent that they have been resized.

## ◆ _notifyBillboardRotated()

virtual void Ogre::v1::BillboardSet::_notifyBillboardRotated | ( | void |  | ) |
| virtual

Internal callback used by Billboards to notify their parent that they have been rotated.

## ◆ _notifyCurrentCamera()

virtual void Ogre::v1::BillboardSet::_notifyCurrentCamera | ( | const Camera * | cam | ) |
| virtual

Overridden from MovableObject.

See also
  MovableObject

## ◆ _notifyManager()

void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) |
| inlineinherited

Notify the object of it's manager (internal use only)

## ◆ _notifyParentNodeMemoryChanged()

virtual void Ogre::MovableObject::_notifyParentNodeMemoryChanged | ( | void |  | ) |
| inlinevirtualinherited

@See Node::_callMemoryChangeListeners

Reimplemented in Ogre::Item.

## ◆ _notifyStaticDirty()

virtual void Ogre::MovableObject::_notifyStaticDirty | ( | void |  | ) | const
| inlinevirtualinherited

Called by SceneManager when it is telling we're a static MovableObject being dirty Don't call this directly.

See also
  SceneManager::notifyStaticDirty

## ◆ _releaseManualHardwareResources()

void Ogre::v1::BillboardSet::_releaseManualHardwareResources | ( |  | ) |
| inlinevirtual

Reimplemented from Ogre::MovableObject.

## ◆ _restoreManualHardwareResources()

virtual void Ogre::MovableObject::_restoreManualHardwareResources | ( |  | ) |
| inlinevirtualinherited

Notifies the movable object that hardware resources should be restored.

Remarks
  Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

## ◆ _setHlmsHashes()

virtual void Ogre::Renderable::_setHlmsHashes | ( | uint32 | hash,
|  | uint32 | casterHash
| ) |  |
| virtualinherited

Manually sets the hlms hashes. Don't call this directly.

Reimplemented in Ogre::SubItem.

## ◆ _setNullDatablock()

virtual void Ogre::v1::BillboardSet::_setNullDatablock | ( | void |  | ) |
| virtual

Sets the datablock to a null pointer.

Use case: If you will be destroying an HlmsDatablock and all Renderables associated by it; it makes no sense to change the Renderable's datablock to a default one, only to be destroyed immediately after (you pay an unnecessary performance price).

Remarks
  Do not attempt to render a Renderable whose datablock has been set to null. It will crash. You can call setDatablock afterwards though. Use at your own risk, hence the _underscore. See http://ogre3d.org/forums/viewtopic.php?f=25&t=91791&p=534476#p534476

Reimplemented from Ogre::Renderable.

## ◆ _sortBillboards()

virtual void Ogre::v1::BillboardSet::_sortBillboards | ( | void |  | ) |
| virtual

Sort the billboard set.

Only called when enabled via setSortingEnabled

## ◆ _updateBounds()

virtual void Ogre::v1::BillboardSet::_updateBounds | ( | void |  | ) |
| virtual

Update the bounds of the billboardset.

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters_AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) |  | const
| virtualinherited

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  constantEntry | The auto constant entry referring to the parameter being updated
  params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::v1::SubEntity.

## ◆ _updateRenderQueue()

virtual void Ogre::v1::BillboardSet::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |
| virtual

Overridden from MovableObject.

See also
  MovableObject

Reimplemented from Ogre::MovableObject.

## ◆ _updateRenderQueueImpl()

void Ogre::v1::BillboardSet::_updateRenderQueueImpl | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera
| ) |  |

Internal version that does not call _notifyCurrentCamera (i.e. you've already done it)

## ◆ addPoseWeight()

void Ogre::Renderable::addPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ addQueryFlags()

void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ addVisibilityFlags()

void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

## ◆ beginBillboards()

void Ogre::v1::BillboardSet::beginBillboards | ( | size_t | numBillboards = `0` | ) |

Begin injection of billboard data; applicable when constructing the BillboardSet for external data use.

Parameters

  numBillboards | If you know the number of billboards you will be issuing, state it here to make the update more efficient.

## ◆ buildLightList()

static void Ogre::MovableObject::buildLightList | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const LightListInfo & | globalLightList
| ) |  |
| staticinherited

@See SceneManager::buildLightList

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

Parameters

  globalLightList | List of lights already culled against all possible frustums and reorganized contiguously for SoA

## ◆ calculateCastersBox()

static void Ogre::MovableObject::calculateCastersBox | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneVisibilityFlags,
|  | AxisAlignedBox * | outBox
| ) |  |
| staticinherited

## ◆ clear()

virtual void Ogre::v1::BillboardSet::clear | ( |  | ) |
| virtual

Empties this set of all billboards.

## ◆ createAnimableValue()

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) |
| inlinevirtualinherited

Create a reference-counted AnimableValuePtr for the named value.

Remarks
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Reimplemented in Ogre::Light.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ createBillboard() [1/2]

Billboard* Ogre::v1::BillboardSet::createBillboard | ( | const Vector3 & | position,
|  | const ColourValue & | colour = `ColourValue::White`
| ) |  |

Creates a new billboard and adds it to this set.

Remarks
  Behaviour once the billboard pool has been exhausted depends on the BillboardSet::setAutoextend option.

Parameters

  position | The position of the new billboard realtive to the certer of the set
  colour | Optional base colour of the billboard.

Returns
  On success, a pointer to a newly created Billboard is returned.

  On failure (i.e. no more space and can't autoextend), `NULL` is returned.

See also
  BillboardSet::setAutoextend

## ◆ createBillboard() [2/2]

Billboard* Ogre::v1::BillboardSet::createBillboard | ( | Real | x,
|  | Real | y,
|  | Real | z,
|  | const ColourValue & | colour = `ColourValue::White`
| ) |  |

Creates a new billboard and adds it to this set.

Remarks
  Behaviour once the billboard pool has been exhausted depends on the BillboardSet::setAutoextend option.

Parameters

  x | The `x` position of the new billboard relative to the center of the set
  y | The `y` position of the new billboard relative to the center of the set
  z | The `z` position of the new billboard relative to the center of the set
  colour | Optional base colour of the billboard.

Returns
  On success, a pointer to a newly created Billboard is returned.

  On failure (i.e. no more space and can't autoextend), `NULL` is returned.

See also
  BillboardSet::setAutoextend

## ◆ cullFrustum()

static void Ogre::MovableObject::cullFrustum | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | frustum,
|  | uint32 | sceneVisibilityFlags,
|  | MovableObjectArray & | outCulledObjects,
|  | const Camera * | lodCamera
| ) |  |
| staticinherited

## ◆ cullLights()

static void Ogre::MovableObject::cullLights | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | uint32 | sceneLightMask,
|  | LightListInfo & | outGlobalLightList,
|  | const FrustumVec & | frustums,
|  | const FrustumVec & | cubemapFrustums
| ) |  |
| staticinherited

@See SceneManager::cullLights &

See also
  MovableObject::cullFrustum Produces the global list of visible lights that is needed in buildLightList

Remarks
  We don't pass ObjectData by reference on purpose (avoid implicit aliasing) It's declared here because all affected elements are from MovableObject IMPORTANT: It is assumed that all objects in ObjectData are Lights.

Parameters

  outGlobalLightList | Output, a list of lights, contiguously placed
  frustums | An array of all frustums we need to check against
  cubemapFrustums | An array of all frustums that are used at least once as cubemaps (@See SceneManager::createCamera)

## ◆ detachFromParent()

void Ogre::MovableObject::detachFromParent | ( | void |  | ) |
| inherited

Detaches an object from a parent SceneNode if attached.

## ◆ endBillboards()

void Ogre::v1::BillboardSet::endBillboards | ( | void |  | ) |

Finish defining billboards.

## ◆ getAnimableValueNames()

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const
| inlineinherited

Gets a list of animable value names for this object.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getAutoextend()

virtual bool Ogre::v1::BillboardSet::getAutoextend | ( | void |  | ) | const
| virtual

Returns true if the billboard pool automatically extends.

See also
  BillboardSet::setAutoextend

## ◆ getAutoUpdate()

bool Ogre::v1::BillboardSet::getAutoUpdate | ( | void |  | ) | const
| inline

Return the auto update state of this billboard set.

## ◆ getBillboard()

virtual Billboard* Ogre::v1::BillboardSet::getBillboard | ( | unsigned int | index | ) | const
| virtual

Returns a pointer to the billboard at the supplied index.

Note
  This method requires linear time since the billboard list is a linked list.

Parameters

  index | The index of the billboard that is requested.

Returns
  On success, a valid pointer to the requested billboard is returned.

  On failure, `NULL` is returned.

## ◆ getBillboardOrigin()

virtual BillboardOrigin Ogre::v1::BillboardSet::getBillboardOrigin | ( | void |  | ) | const
| virtual

Gets the point which acts as the origin point for all billboards in this set.

Returns
  A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

Referenced by Ogre::v1::BillboardParticleRenderer::getBillboardOrigin().

## ◆ getBillboardRotationType()

virtual BillboardRotationType Ogre::v1::BillboardSet::getBillboardRotationType | ( | void |  | ) | const
| virtual

Sets billboard rotation type.

Returns
  A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ getBillboardsInWorldSpace()

bool Ogre::v1::BillboardSet::getBillboardsInWorldSpace | ( |  | ) |
| inline

Gets whether billboards are treated as being in world space.

## ◆ getBillboardType()

virtual BillboardType Ogre::v1::BillboardSet::getBillboardType | ( | void |  | ) | const
| virtual

Returns the billboard type in use.

## ◆ getCachedDistanceToCamera()

RealAsUint Ogre::MovableObject::getCachedDistanceToCamera | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCachedDistanceToCameraAsReal()

Real Ogre::MovableObject::getCachedDistanceToCameraAsReal | ( | void |  | ) | const
| inlineinherited

Returns the distance to camera as calculated in @cullFrustum.

## ◆ getCastShadows()

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const
| inlineinherited

Returns whether shadow casting is enabled for this object.

## ◆ getCastsShadows()

virtual bool Ogre::Renderable::getCastsShadows | ( | void |  | ) | const
| inlinevirtualinherited

Method which reports whether this renderable would normally cast a shadow.

Remarks
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented in Ogre::ManualObject::ManualObjectSection, Ogre::WireAabb, Ogre::SubItem, Ogre::v1::SubEntity, Ogre::v1::StaticGeometry::GeometryBucket, Ogre::Rectangle2D, Ogre::VoxelVisualizer, and Ogre::IfdProbeVisualizer.

## ◆ getCommonDirection()

virtual const Vector3& Ogre::v1::BillboardSet::getCommonDirection | ( | void |  | ) | const
| virtual

Gets the common direction for all billboards (BBT_ORIENTED_COMMON)

## ◆ getCommonUpVector()

virtual const Vector3& Ogre::v1::BillboardSet::getCommonUpVector | ( | void |  | ) | const
| virtual

Gets the common up-vector for all billboards (BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON)

## ◆ getCullIndividually()

virtual bool Ogre::v1::BillboardSet::getCullIndividually | ( | void |  | ) | const
| virtual

Returns whether or not billboards in this are tested individually for culling.

## ◆ getCurrentMaterialLod()

uint8 Ogre::Renderable::getCurrentMaterialLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCurrentMeshLod()

unsigned char Ogre::MovableObject::getCurrentMeshLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCustomParameter()

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Gets the custom value associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to retrieve.

See also
  setCustomParameter for full details.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCustomParameters()

const CustomParameterMap& Ogre::Renderable::getCustomParameters | ( | void |  | ) | const
| inlineinherited

## ◆ getDatablock()

HlmsDatablock* Ogre::Renderable::getDatablock | ( | void |  | ) | const
| inlineinherited

## ◆ getDefaultHeight()

virtual Real Ogre::v1::BillboardSet::getDefaultHeight | ( | void |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getDefaultLightMask()

static uint32 Ogre::MovableObject::getDefaultLightMask | ( |  | ) |
| inlinestaticinherited

Get the default light mask for all future MovableObject instances.

## ◆ getDefaultQueryFlags()

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) |
| inlinestaticinherited

Get the default query flags for all future MovableObject instances.

## ◆ getDefaultVisibilityFlags()

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) |
| inlinestaticinherited

Get the default visibility flags for all future MovableObject instances.

## ◆ getDefaultWidth()

virtual Real Ogre::v1::BillboardSet::getDefaultWidth | ( | void |  | ) | const
| virtual

See setDefaultDimensions - this gets 1 component individually.

## ◆ getHlmsCasterHash()

uint32 Ogre::Renderable::getHlmsCasterHash | ( | void |  | ) | const
| inlineinherited

## ◆ getHlmsHash()

uint32 Ogre::Renderable::getHlmsHash | ( | void |  | ) | const
| inlineinherited

## ◆ getId()

IdType Ogre::IdObject::getId | ( |  | ) | const
| inlineinherited

Get the unique id of this object.

## ◆ getLightMask()

uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const
| inlineinherited

Get a bitwise mask which will filter the lights affecting this object.

Remarks
  By default, this mask is fully set meaning all lights will affect this object

## ◆ getLights()

const LightList& Ogre::v1::BillboardSet::getLights | ( | void |  | ) | const
| virtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getListener()

Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const
| inlineinherited

Gets the current listener for this object.

## ◆ getLocalAabb()

Aabb Ogre::MovableObject::getLocalAabb | ( | void |  | ) | const
| inherited

Retrieves the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ getLocalRadius()

float Ogre::MovableObject::getLocalRadius | ( | void |  | ) | const
| inherited

See getLocalAabb and getWorldRadius.

## ◆ getMaterial()

MaterialPtr Ogre::Renderable::getMaterial | ( | void |  | ) | const
| inherited

Retrieves the material this renderable object uses.

It may be null if it's using the HLMS. @See getDatablock

## ◆ getMovableType()

virtual const String& Ogre::v1::BillboardSet::getMovableType | ( | void |  | ) | const
| virtual

Overridden from MovableObject.

Implements Ogre::MovableObject.

## ◆ getName()

const String& Ogre::MovableObject::getName | ( | void |  | ) | const
| inlineinherited

Returns the name of this object.

## ◆ getNumBillboards()

virtual int Ogre::v1::BillboardSet::getNumBillboards | ( | void |  | ) | const
| virtual

Returns the number of active billboards which currently make up this set.

## ◆ getNumPoses()

unsigned short Ogre::Renderable::getNumPoses | ( | void |  | ) | const
| inherited

## ◆ getNumWorldTransforms()

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const
| inlinevirtualinherited

Returns the number of world transform matrices this renderable requires.

Remarks
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BorderRenderable.

## ◆ getParentNode()

Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const
| inlineinherited

Returns the node to which this object is attached.

## ◆ getParentSceneNode()

SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const
| inlineinherited

## ◆ getPolygonModeOverrideable()

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const
| inlinevirtualinherited

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::v1::BorderRenderable.

Referenced by Ogre::v1::BorderRenderable::getPolygonModeOverrideable().

## ◆ getPoolSize()

virtual unsigned int Ogre::v1::BillboardSet::getPoolSize | ( | void |  | ) | const
| virtual

Returns the current size of the billboard pool.

Returns
  The current size of the billboard pool.

See also
  BillboardSet::setAutoextend

## ◆ getPoseHalfPrecision()

bool Ogre::Renderable::getPoseHalfPrecision | ( |  | ) | const
| inherited

## ◆ getPoseNormals()

bool Ogre::Renderable::getPoseNormals | ( |  | ) | const
| inherited

## ◆ getPoseTexBuffer()

TexBufferPacked* Ogre::Renderable::getPoseTexBuffer | ( |  | ) | const
| inherited

## ◆ getPoseWeight()

float Ogre::Renderable::getPoseWeight | ( | size_t | index | ) | const
| inherited

## ◆ getPoseWeights()

float* Ogre::Renderable::getPoseWeights | ( |  | ) | const
| inherited

## ◆ getQueryFlags()

uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const
| inlineinherited

Returns the query flags relevant for this object.

## ◆ getRenderingDistance()

Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer rendered.

## ◆ getRenderingMinPixelSize()

Real Ogre::MovableObject::getRenderingMinPixelSize | ( |  | ) | const
| inlineinherited

Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.

## ◆ getRenderOperation()

virtual void Ogre::v1::BillboardSet::getRenderOperation | ( | RenderOperation & | op,
|  | bool | casterPass
| ) |  |
| virtual

Overridden from MovableObject.

See also
  MovableObject

Implements Ogre::Renderable.

## ◆ getRenderQueueGroup()

uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const
| inlineinherited

Gets the queue group for this entity, see setRenderQueueGroup for full details.

## ◆ getRenderQueueSubGroup()

uint8 Ogre::Renderable::getRenderQueueSubGroup | ( | void |  | ) | const
| inlineinherited

## ◆ getShadowRenderingDistance()

Real Ogre::MovableObject::getShadowRenderingDistance | ( | void |  | ) | const
| inlineinherited

Gets the distance at which batches are no longer casting shadows.

## ◆ getSkeletonInstance()

SkeletonInstance* Ogre::MovableObject::getSkeletonInstance | ( | void |  | ) | const
| inlineinherited

## ◆ getSortingEnabled()

virtual bool Ogre::v1::BillboardSet::getSortingEnabled | ( | void |  | ) | const
| virtual

Returns true if sorting of billboards is enabled based on their distance from the camera.

See also
  BillboardSet::setSortingEnabled

## ◆ getSquaredViewDepth()

Real Ogre::v1::BillboardSet::getSquaredViewDepth | ( | const Camera * | cam | ) | const

Overridden, see Renderable.

## ◆ getTextureCoords()

virtual Ogre::FloatRect const* Ogre::v1::BillboardSet::getTextureCoords | ( | uint16 * | oNumCoords | ) |
| virtual

getTextureCoords() returns the current texture coordinate rects in effect.

By default, there is only one texture coordinate rect in the set, spanning the entire texture from 0 through 1 in each direction.

See also
  BillboardSet::setTextureCoords()

## ◆ getUseAccurateFacing()

virtual bool Ogre::v1::BillboardSet::getUseAccurateFacing | ( | void |  | ) | const
| inlinevirtual

Gets whether or not billboards use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

## ◆ getUseIdentityProjection()

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityProjection

## ◆ getUseIdentityView()

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityView

## ◆ getUseIdentityViewProjMatrixIsDynamic()

virtual bool Ogre::Renderable::getUseIdentityViewProjMatrixIsDynamic | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)

Remarks
  Hlms implementations may ignore this setting (e.g. assume always true or always false) or even not support identity matrix overrides at all. For example currently Unlit supports them all, but will assume this returns always true if getUseIdentityWorldMatrix returns false.

## ◆ getUseIdentityWorldMatrix()

virtual bool Ogre::v1::BillboardSet::getUseIdentityWorldMatrix | ( | void |  | ) | const
| virtual

Overriden from Renderable.

Reimplemented from Ogre::Renderable.

## ◆ getUserAny()

virtual OGRE_DEPRECATED const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead. Retrieves the custom user value associated with this object.

## ◆ getUserObjectBindings() [1/4]

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/4]

UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [3/4]

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [4/4]

const UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVaos()

const VertexArrayObjectArray& Ogre::Renderable::getVaos | ( | VertexPass | vertexPass | ) | const
| inlineinherited

## ◆ getVisibilityFlags()

uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const
| inlineinherited

Returns the visibility flags relevant for this object.

Reserved visibility flags are not returned.

## ◆ getVisible()

bool Ogre::MovableObject::getVisible | ( | void |  | ) | const
| inlineinherited

Gets this object whether to be visible or not, if it has a renderable component.

Remarks
  Returns the value set by MovableObject::setVisible only.

## ◆ getWorldAabb()

Aabb Ogre::MovableObject::getWorldAabb | ( |  | ) | const
| inherited

Gets the axis aligned box in world space.

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldAabbUpdated if you need the update process to be guaranteed

## ◆ getWorldAabbUpdated()

Aabb Ogre::MovableObject::getWorldAabbUpdated | ( |  | ) |
| inherited

Gets the axis aligned box in world space.

Remarks
  Unlike getWorldAabb, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldRadius()

float Ogre::MovableObject::getWorldRadius | ( |  | ) | const
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Assumes the caches are already updated. Will trigger an assert otherwise. @See getWorldRadiusUpdated if you need the update process to be guaranteed

## ◆ getWorldRadiusUpdated()

float Ogre::MovableObject::getWorldRadiusUpdated | ( |  | ) |
| inherited

Gets the bounding Radius scaled by max( scale.x, scale.y, scale.z ).

Remarks
  Unlike getWorldRadius, this function guarantees the cache stays up to date. It is STRONGLY advised against calling this function for a large number of MovableObject. Refactor your queries so that they happen after SceneManager::updateAllBounds() has been called

## ◆ getWorldTransforms()

virtual void Ogre::v1::BillboardSet::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| virtual

Overridden from MovableObject.

See also
  MovableObject

Implements Ogre::Renderable.

## ◆ hasCustomParameter()

bool Ogre::Renderable::hasCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Checks whether a custom value is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to check for existence.

See also
  setCustomParameter for full details.

## ◆ hasSkeletonAnimation()

bool Ogre::Renderable::hasSkeletonAnimation | ( | void |  | ) | const
| inlineinherited

## ◆ injectBillboard()

void Ogre::v1::BillboardSet::injectBillboard | ( | const Billboard & | bb,
|  | const Camera * | camera
| ) |  |

Define a billboard.

## ◆ instanceBatchCullFrustumThreaded()

virtual void Ogre::MovableObject::instanceBatchCullFrustumThreaded | ( | const Frustum * | frustum,
|  | const Camera * | lodCamera,
|  | uint32 | combinedVisibilityFlags
| ) |  |
| inlinevirtualinherited

@See InstancingTheadedCullingMethod,

See also
  InstanceBatch::instanceBatchCullFrustumThreaded

## ◆ isAttached()

bool Ogre::MovableObject::isAttached | ( | void |  | ) | const
| inlineinherited

Returns true if this object is attached to a Node.

## ◆ isPointRenderingEnabled()

virtual bool Ogre::v1::BillboardSet::isPointRenderingEnabled | ( | void |  | ) | const
| inlinevirtual

Returns whether point rendering is enabled.

## ◆ isStatic()

bool Ogre::MovableObject::isStatic | ( |  | ) | const
| inherited

Checks whether this MovableObject is static. @See setStatic.

## ◆ isVisible()

bool Ogre::MovableObject::isVisible | ( | void |  | ) | const
| inherited

Returns whether or not this object is supposed to be visible or not.

Remarks
  Takes into account visibility flags and the setVisible, but not rendering distance.

## ◆ notifyBillboardDataChanged()

void Ogre::v1::BillboardSet::notifyBillboardDataChanged | ( | void |  | ) |
| inline

When billboard set is not auto updating its GPU buffer, the user is responsible to inform it about any billboard changes in order to reflect them at the rendering stage.

Calling this method will cause GPU buffers update in the next render queue update.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ operator()() [1/2]

bool Ogre::IdObject::operator() | ( | const IdObject & | left,
|  | const IdObject & | right
| ) |  |
| inlineinherited

## ◆ operator()() [2/2]

bool Ogre::IdObject::operator() | ( | const IdObject * | left,
|  | const IdObject * | right
| ) |  |
| inlineinherited

## ◆ postRender()

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called immediately after the Renderable has been rendered.

## ◆ preRender()

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called just prior to the Renderable being rendered.

Remarks
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented in Ogre::v1::BillboardChain.

## ◆ queryLights()

const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const
| inlineinherited

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks
  The lights are filled in

See also
  buildLightList

Returns
  The list of lights use to lighting this object.

## ◆ removeBillboard() [1/2]

virtual void Ogre::v1::BillboardSet::removeBillboard | ( | Billboard * | pBill | ) |
| virtual

Removes a billboard from the set.

Note
  This version is more efficient than removing by index.

## ◆ removeBillboard() [2/2]

virtual void Ogre::v1::BillboardSet::removeBillboard | ( | unsigned int | index | ) |
| virtual

Removes the billboard at the supplied index.

Note
  This method requires linear time since the billboard list is a linked list.

## ◆ removeCustomParameter()

void Ogre::Renderable::removeCustomParameter | ( | size_t | index | ) |
| inlineinherited

Removes a custom value which is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to remove.

See also
  setCustomParameter for full details.

## ◆ removeQueryFlags()

void Ogre::MovableObject::removeQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ removeVisibilityFlags()

void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

## ◆ setAutoextend()

virtual void Ogre::v1::BillboardSet::setAutoextend | ( | bool | autoextend | ) |
| virtual

Tells the set whether to allow automatic extension of the pool of billboards.

Remarks
  A BillboardSet stores a pool of pre-constructed billboards which are used as needed when a new billboard is requested. This allows applications to create / remove billboards efficiently without incurring construction / destruction costs (a must for sets with lots of billboards like particle effects). This method allows you to configure the behaviour when a new billboard is requested but the billboard pool has been exhausted.

  The default behaviour is to allow the pool to extend (typically this allocates double the current pool of billboards when the pool is expended), equivalent to calling this method with autoExtend = true. If you set the parameter to false however, any attempt to create a new billboard when the pool has expired will simply fail silently, returning a null pointer.

Parameters

  autoextend | `true` to double the pool every time it runs out, `false` to fail silently.

## ◆ setAutoUpdate()

void Ogre::v1::BillboardSet::setAutoUpdate | ( | bool | autoUpdate | ) |

Set the auto update state of this billboard set.

Remarks
  This methods controls the updating policy of the vertex buffer. By default auto update is true so the vertex buffer is being update every time this billboard set is about to be rendered. This behavior best fit when the billboards of this set changes frequently. When using static or semi-static billboards, it is recommended to set auto update to false. In that case one should call notifyBillboardDataChanged method to reflect changes made to the billboards data.

## ◆ setBillboardOrigin()

virtual void Ogre::v1::BillboardSet::setBillboardOrigin | ( | BillboardOrigin | origin | ) |
| virtual

Sets the point which acts as the origin point for all billboards in this set.

Remarks
  This setting controls the fine tuning of where a billboard appears in relation to it's position. It could be that a billboard's position represents it's center (e.g. for fireballs), it could mean the center of the bottom edge (e.g. a tree which is positioned on the ground), the top-left corner (e.g. a cursor).

  The default setting is BBO_CENTER.

Parameters

  origin | A member of the BillboardOrigin enum specifying the origin for all the billboards in this set.

Referenced by Ogre::v1::BillboardParticleRenderer::setBillboardOrigin().

## ◆ setBillboardRotationType()

virtual void Ogre::v1::BillboardSet::setBillboardRotationType | ( | BillboardRotationType | rotationType | ) |
| virtual

Sets billboard rotation type.

Remarks
  This setting controls the billboard rotation type, you can deciding rotate the billboard's vertices around their facing direction or rotate the billboard's texture coordinates.

  The default settings is BBR_TEXCOORD.

Parameters

  rotationType | A member of the BillboardRotationType enum specifying the rotation type for all the billboards in this set.

## ◆ setBillboardsInWorldSpace()

virtual void Ogre::v1::BillboardSet::setBillboardsInWorldSpace | ( | bool | ws | ) |
| inlinevirtual

Sets whether billboards should be treated as being in world space.

Remarks
  This is most useful when you are driving the billboard set from an external data source.

## ◆ setBillboardType()

virtual void Ogre::v1::BillboardSet::setBillboardType | ( | BillboardType | bbt | ) |
| virtual

Sets the type of billboard to render.

Remarks
  The default sort of billboard (BBT_POINT), always has both x and y axes parallel to the camera's local axes. This is fine for 'point' style billboards (e.g. flares, smoke, anything which is symmetrical about a central point) but does not look good for billboards which have an orientation (e.g. an elongated raindrop). In this case, the oriented billboards are more suitable (BBT_ORIENTED_COMMON or BBT_ORIENTED_SELF) since they retain an independent Y axis and only the X axis is generated, perpendicular to both the local Y and the camera Z.

  In some case you might want the billboard has fixed Z axis and doesn't need to face to camera (e.g. an aureola around the player and parallel to the ground). You can use BBT_PERPENDICULAR_SELF which the billboard plane perpendicular to the billboard own direction. Or BBT_PERPENDICULAR_COMMON which the billboard plane perpendicular to the common direction.

Note
  BBT_PERPENDICULAR_SELF and BBT_PERPENDICULAR_COMMON can't guarantee counterclockwise, you might use double-side material (cull_hardware node) to ensure no billboard are culled.

Parameters

  bbt | The type of billboard to render

## ◆ setBounds()

void Ogre::v1::BillboardSet::setBounds | ( | const Aabb & | aabb,
|  | Real | radius
| ) |  |

Set the bounds of the BillboardSet.

Remarks
  You may need to call this if you're injecting billboards manually, and you're relying on the BillboardSet to determine culling.

## ◆ setCastShadows()

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) |
| inlineinherited

Sets whether or not this object will cast shadows.

Remarks
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

## ◆ setCommonDirection()

virtual void Ogre::v1::BillboardSet::setCommonDirection | ( | const Vector3 & | vec | ) |
| virtual

Use this to specify the common direction given to billboards of type BBT_ORIENTED_COMMON or BBT_PERPENDICULAR_COMMON.

Remarks
  Use BBT_ORIENTED_COMMON when you want oriented billboards but you know they are always going to be oriented the same way (e.g. rain in calm weather). It is faster for the system to calculate the billboard vertices if they have a common direction.

  The common direction also use in BBT_PERPENDICULAR_COMMON, in this case the common direction treat as Z axis, and an additional common up-vector was use to determine billboard X and Y axis.

See also
  setCommonUpVector

Parameters

  vec | The direction for all billboards.

Note
  The direction are use as is, never normalised in internal, user are supposed to normalise it himself.

## ◆ setCommonUpVector()

virtual void Ogre::v1::BillboardSet::setCommonUpVector | ( | const Vector3 & | vec | ) |
| virtual

Use this to specify the common up-vector given to billboards of type BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON.

Remarks
  Use BBT_PERPENDICULAR_SELF or BBT_PERPENDICULAR_COMMON when you want oriented billboards perpendicular to specify direction vector (or, Z axis), and doesn't face to camera. In this case, we need an additional up-vector to determine the billboard X and Y axis. The generated billboard plane and X-axis guarantee perpendicular to specify direction.

See also
  setCommonDirection

  The specify direction is billboard own direction when billboard type is BBT_PERPENDICULAR_SELF, and it's shared common direction when billboard type is BBT_PERPENDICULAR_COMMON.

Parameters

  vec | The up-vector for all billboards.

Note
  The up-vector are use as is, never normalised in internal, user are supposed to normalise it himself.

## ◆ setCullIndividually()

virtual void Ogre::v1::BillboardSet::setCullIndividually | ( | bool | cullIndividual | ) |
| virtual

Sets whether culling tests billboards in this individually as well as in a group.

Remarks
  Billboard sets are always culled as a whole group, based on a bounding box which encloses all billboards in the set. For fairly localised sets, this is enough. However, you can optionally tell the set to also cull individual billboards in the set, i.e. to test each individual billboard before rendering. The default is not to do this.

  This is useful when you have a large, fairly distributed set of billboards, like maybe trees on a landscape. You probably still want to group them into more than one set (maybe one set per section of landscape), which will be culled coarsely, but you also want to cull the billboards individually because they are spread out. Whilst you could have lots of single-tree sets which are culled separately, this would be inefficient to render because each tree would be issued as it's own rendering operation.

  By calling this method with a parameter of true, you can have large billboard sets which are spaced out and so get the benefit of batch rendering and coarse culling, but also have fine-grained culling so unnecessary rendering is avoided.

Parameters

  cullIndividual | If true, each billboard is tested before being sent to the pipeline as well as the whole set having to pass the coarse group bounding test.

## ◆ setCustomParameter()

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) |  |
| inlineinherited

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ setDatablock() [1/2]

virtual void Ogre::v1::BillboardSet::setDatablock | ( | HlmsDatablock * | datablock | ) |
| virtual

Assigns a datablock (i.e. HLMS Material) to this renderable.

Reimplemented from Ogre::Renderable.

## ◆ setDatablock() [2/2]

void Ogre::Renderable::setDatablock | ( | IdString | datablockName | ) |
| inherited

Assigns a datablock (i.e.

HLMS material) based on its unique name.

Remarks
  An null IdString() is valid, it will use the default material

## ◆ setDatablockOrMaterialName()

void Ogre::Renderable::setDatablockOrMaterialName | ( | String | materialName,
|  | String | groupName
| ) |  |
| inherited

First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.

## ◆ setDefaultDimensions()

virtual void Ogre::v1::BillboardSet::setDefaultDimensions | ( | Real | width,
|  | Real | height
| ) |  |
| virtual

Sets the default dimensions of the billboards in this set.

Remarks
  All billboards in a set are created with these default dimensions. The set will render most efficiently if all the billboards in the set are the default size. It is possible to alter the size of individual billboards at the expense of extra calculation. See the Billboard class for more info.

Parameters

  width | The new default width for the billboards in this set.
  height | The new default height for the billboards in this set.

## ◆ setDefaultHeight()

virtual void Ogre::v1::BillboardSet::setDefaultHeight | ( | Real | height | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setDefaultLightMask()

static void Ogre::MovableObject::setDefaultLightMask | ( | uint32 | mask | ) |
| inlinestaticinherited

Set the default light mask for all future MovableObject instances.

## ◆ setDefaultQueryFlags()

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default query flags for all future MovableObject instances.

## ◆ setDefaultVisibilityFlags()

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) |
| inlinestaticinherited

Set the default visibility flags for all future MovableObject instances.

## ◆ setDefaultWidth()

virtual void Ogre::v1::BillboardSet::setDefaultWidth | ( | Real | width | ) |
| virtual

See setDefaultDimensions - this sets 1 component individually.

## ◆ setLightMask()

void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) |
| inlineinherited

Set a bitwise mask which will filter the lights affecting this object.

Remarks
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

## ◆ setListener()

void Ogre::MovableObject::setListener | ( | Listener * | listener | ) |
| inlineinherited

Sets a listener for this object.

Remarks
  Note for size and performance reasons only one listener per object is allowed.

## ◆ setLocalAabb()

void Ogre::MovableObject::setLocalAabb | ( | const Aabb | box | ) |
| inherited

Sets the local axis-aligned bounding box for this object.

Remarks
  This bounding box is in local coordinates.

## ◆ setMaterial()

virtual void Ogre::v1::BillboardSet::setMaterial | ( | const MaterialPtr & | material | ) |
| virtual

Sets the given material. Overrides HLMS materials.

Reimplemented from Ogre::Renderable.

## ◆ setMaterialName()

void Ogre::Renderable::setMaterialName | ( | const String & | name,
|  | const String & | groupName
| ) |  |
| inherited

Sets the name of the Material to be used. Prefer using HLMS @See setHlms.

## ◆ setName()

void Ogre::MovableObject::setName | ( | const String & | name | ) |
| inlineinherited

Sets a custom name for this node.

Doesn't have to be unique

## ◆ setPointRenderingEnabled()

virtual void Ogre::v1::BillboardSet::setPointRenderingEnabled | ( | bool | enabled | ) |
| virtual

Set whether or not the BillboardSet will use point rendering rather than manually generated quads.

Remarks
  By default a billboardset is rendered by generating geometry for a textured quad in memory, taking into account the size and orientation settings, and uploading it to the video card. The alternative is to use hardware point rendering, which means that only one position needs to be sent per billboard rather than 4 and the hardware sorts out how this is rendered based on the render state.

  Using point rendering is faster than generating quads manually, but is more restrictive. The following restrictions apply:
  - Only the BBT_POINT type is supported
  - Size and appearance of each billboard is controlled by the material (Pass::setPointSize, Pass::setPointSizeAttenuation, Pass::setPointSpritesEnabled)
  - Per-billboard size is not supported (stems from the above)
  - Per-billboard rotation is not supported, this can only be controlled through texture unit rotation
  - Only BBO_CENTER origin is supported
  - Per-billboard texture coordinates are not supported

  You will almost certainly want to enable in your material pass both point attenuation and point sprites if you use this option.

Parameters

  enabled | True to enable point rendering, false otherwise

## ◆ setPolygonModeOverrideable()

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) |
| inlinevirtualinherited

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters

  override | true means that a lower camera detail will override this renderables detail level, false means it won't.

## ◆ setPoolSize()

virtual void Ogre::v1::BillboardSet::setPoolSize | ( | size_t | size | ) |
| virtual

Adjusts the size of the pool of billboards available in this set.

Remarks
  See the BillboardSet::setAutoextend method for full details of the billboard pool. This method adjusts the preallocated size of the pool. If you try to reduce the size of the pool, the set has the option of ignoring you if too many billboards are already in use. Bear in mind that calling this method will incur significant construction / destruction calls so should be avoided in time-critical code. The same goes for auto-extension, try to avoid it by estimating the pool size correctly up-front.

Parameters

  size | The new size for the pool.

## ◆ setPoseWeight()

void Ogre::Renderable::setPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ setQueryFlags()

void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the query flags for this object.

Remarks
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

## ◆ setRenderingDistance()

void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer rendered.

Parameters

  dist | Distance beyond which the object will not be rendered (the default is FLT_MAX, which means objects are always rendered). Values equal or below zero will be ignored, and cause an assertion in debug mode.

## ◆ setRenderingMinPixelSize()

void Ogre::MovableObject::setRenderingMinPixelSize | ( | Real | pixelSize | ) |
| inlineinherited

Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.

Note
  Camera::setUseMinPixelSize() needs to be called for this parameter to be used.

Parameters

  pixelSize | Number of minimum pixels (the default is 0, which means objects are always rendered).

## ◆ setRenderQueueGroup()

virtual void Ogre::MovableObject::setRenderQueueGroup | ( | uint8 | queueID | ) |
| virtualinherited

Sets the render queue group this entity will be rendered through.

Remarks
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters

  queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

  Valid render queue ids are between 0 & 254 inclusive

Reimplemented in Ogre::ParticleSystem, Ogre::Light, Ogre::InternalCubemapProbe, Ogre::v1::Entity, and Ogre::Decal.

## ◆ setRenderQueueSubGroup()

void Ogre::Renderable::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| inlineinherited

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits ) @See RenderQueue

## ◆ setShadowRenderingDistance()

void Ogre::MovableObject::setShadowRenderingDistance | ( | Real | dist | ) |
| inlineinherited

Sets the distance at which the object is no longer casting shadows.

Parameters

  dist | Distance beyond which the object will not cast shadows (the default is FLT_MAX, which means objects are always casting shadows). Values equal or below zero will be ignored, and cause an assertion in debug mode.

Note
  ShadowRenderingDistance will be clamped to RenderingDistance value

See also
  setRenderingDistance

## ◆ setSortingEnabled()

virtual void Ogre::v1::BillboardSet::setSortingEnabled | ( | bool | sortenable | ) |
| virtual

Enables sorting for this BillboardSet.

(default: off)

Parameters

  sortenable | true to sort the billboards according to their distance to the camera

## ◆ setStatic()

bool Ogre::MovableObject::setStatic | ( | bool | bStatic | ) |
| inherited

Turns this Node into static or dynamic.

Remarks
  Switching between dynamic and static has some overhead and forces to update all static scene when converted to static. So don't do it frequently. Static objects are not updated every frame, only when requested explicitly. Use this feature if you plan to have this object unaltered for a very long times

  Note all MovableObjects support switching between static & dynamic after they have been created (eg. InstancedEntity)

  Changing this attribute will cause to switch the attribute to our parent node, and as a result, all of its other attached entities. @See Node::setStatic

Returns
  True if setStatic made an actual change. False otherwise. Can fail because the object was already static/dynamic, or because switching is not supported

## ◆ setTextureCoords()

virtual void Ogre::v1::BillboardSet::setTextureCoords | ( | Ogre::FloatRect const * | coords,
|  | uint16 | numCoords
| ) |  |
| virtual

BillboardSet can use custom texture coordinates for various billboards.

This is useful for selecting one of many particle images out of a tiled texture sheet, or doing flipbook animation within a single texture.

  The generic functionality is setTextureCoords(), which will copy the texture coordinate rects you supply into internal storage for the billboard set. If your texture sheet is a square grid, you can also use setTextureStacksAndSlices() for more convenience, which will construct the set of texture coordinates for you.

  When a Billboard is created, it can be assigned a texture coordinate set from within the sets you specify (that set can also be re-specified later). When drawn, the billboard will use those texture coordinates, rather than the full 0-1 range.

Parameters

  coords | is a vector of texture coordinates (in UV space) to choose from for each billboard created in the set.
  numCoords | is how many such coordinate rectangles there are to choose from.

Remarks
  Set 'coords' to 0 and/or 'numCoords' to 0 to reset the texture coord rects to the initial set of a single rectangle spanning 0 through 1 in both U and V (i e, the entire texture).

See also
  BillboardSet::setTextureStacksAndSlices() Billboard::setTexcoordIndex()

## ◆ setTextureStacksAndSlices()

virtual void Ogre::v1::BillboardSet::setTextureStacksAndSlices | ( | uchar | stacks,
|  | uchar | slices
| ) |  |
| virtual

setTextureStacksAndSlices() will generate texture coordinate rects as if the texture for the billboard set contained 'stacks' rows of 'slices' images each, all equal size.

Thus, if the texture size is 512x512 and 'stacks' is 4 and 'slices' is 8, each sub-rectangle of the texture would be 128 texels tall and 64 texels wide.

Remarks
  This function is short-hand for creating a regular set and calling setTextureCoords() yourself. The numbering used for Billboard::setTexcoordIndex() counts first across, then down, so top-left is 0, the one to the right of that is 1, and the lower-right is stacks*slices-1.

See also
  BillboardSet::setTextureCoords()

## ◆ setUseAccurateFacing()

virtual void Ogre::v1::BillboardSet::setUseAccurateFacing | ( | bool | acc | ) |
| inlinevirtual

Sets whether or not billboards should use an 'accurate' facing model based on the vector from each billboard to the camera, rather than an optimised version using just the camera direction.

Remarks
  By default, the axes for all billboards are calculated using the camera's view direction, not the vector from the camera position to the billboard. The former is faster, and most of the time the difference is not noticeable. However for some purposes (e.g. very large, static billboards) the changing billboard orientation when rotating the camera can be off putting, therefore you can enable this option to use a more expensive, but more accurate version.

Parameters

  acc | True to use the slower but more accurate model. Default is false.

## ◆ setUseIdentityProjection()

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |
| inlineinherited

Sets whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) |
| inlineinherited

Sets whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityView

## ◆ setUserAny()

virtual OGRE_DEPRECATED void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) |
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead. Sets any kind of user value on this object.

Remarks
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

## ◆ setVisibilityFlags()

void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) |
| inlineinherited

Sets the visibility flags for this object.

Remarks
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visibility flags that is applied a binary 'and' with the SceneManager's mask and a compositor node pass. To exclude particular objects from rendering. Changes to reserved visibility flags are ignored (won't take effect).

## ◆ setVisible()

void Ogre::MovableObject::setVisible | ( | bool | visible | ) |
| inlineinherited

Tells this object whether to be visible or not, if it has a renderable component.

Note
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

## ◆ updateAllBounds()

static void Ogre::MovableObject::updateAllBounds | ( | const size_t | numNodes,
|  | ObjectData | t
| ) |  |
| staticinherited

@See SceneManager::updateAllBounds

Remarks
  We don't pass by reference on purpose (avoid implicit aliasing)

## Member Data Documentation

## ◆ c_DefaultLodMesh

const FastArray<Real> Ogre::MovableObject::c_DefaultLodMesh
| staticinherited

## ◆ mCustomParameter

uint8 Ogre::Renderable::mCustomParameter
| inherited

Only valid when using low level materials.

## ◆ mGlobalIndex

size_t Ogre::MovableObject::mGlobalIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mHlmsGlobalIndex

uint32 Ogre::Renderable::mHlmsGlobalIndex
| inherited

Index in the vector holding this Rendrable reference in the HLMS datablock.

Used for O(1) removals.

Remarks
  Despite being public, Do NOT modify it manually.

## ◆ mParentIndex

size_t Ogre::MovableObject::mParentIndex
| inherited

Index in the vector holding this MO reference (could be our parent node, or a global array tracking all movable objecst to avoid memory leaks).

Used for O(1) removals.

Remarks
  It is the parent (or our creator) the one that sets this value, not ourselves. Do NOT modify it manually.

## ◆ mRenderables

RenderableArray Ogre::MovableObject::mRenderables
| inherited

The documentation for this class was generated from the following file:

- OgreBillboardSet.h